## lightspark-0.8.7.tar.gz

=== CMakeLists.txt ===
#**************************************************************************
#    Lightspark, a free flash player implementation
#
#    Copyright (C) 2010-2013  Alessandro Pignotti <a.pignotti@sssup.it>
#    Copyright (C) 2010  Giacomo Spigler <g.spigler@sssup.it>
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Lesser General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Lesser General Public License for more details.
#
#   You should have received a copy of the GNU Lesser General Public License
#   along with this program.  If not, see <http://www.gnu.org/licenses/>.
#**************************************************************************


CMAKE_MINIMUM_REQUIRED(VERSION 2.6...3.19)

# Name & Version
PROJECT(LIGHTSPARK)
SET(MAJOR_VERSION "0")
SET(MINOR_VERSION "8")
SET(PATCH_VERSION "7")
SET(SUBPATCH_VERSION "0")

IF(EXISTS "${CMAKE_SOURCE_DIR}/.git/")
	SET(GIT_VERSION "-git")

	#Find out if we are exactly at a tag. Then the version
	#is enough. Only consider the official release tags like
	#'lightspark-0.5.3'
	EXECUTE_PROCESS(COMMAND git describe --match "lightspark-*" --tags
			WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
			OUTPUT_VARIABLE GIT_DESC
			ERROR_QUIET
			OUTPUT_STRIP_TRAILING_WHITESPACE)
	#Check if that command failed (maybe git is not installed at all)
	IF(GIT_DESC)
		EXECUTE_PROCESS(COMMAND git describe --match "lightspark-*" --tags --abbrev=0
				WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
				OUTPUT_VARIABLE GIT_DESC_ABBREV
				ERROR_QUIET
				OUTPUT_STRIP_TRAILING_WHITESPACE)

		IF(${GIT_DESC} STREQUAL ${GIT_DESC_ABBREV})
			#We are exactly at a tag
			SET(GIT_VERSION "")
		ELSE()
			#Append to GIT_VERSION
			#GIT_DESC_ABBREV is of the form lightspark-0.5.3 (the name of the previous tag)
			#GIT_DESC is of the form lightspark-0.5.3-69-gf49ec56 (tag-numberOfCommits-currentHash)
			#We want GIT_REVISION to be 69-gf49ec56
			#which denotes the number of commits since the last tag (=release)
			#and the current commit's hash
			STRING(REPLACE "${GIT_DESC_ABBREV}-" "" GIT_REVISION "${GIT_DESC}")
			SET(GIT_VERSION "-${GIT_REVISION}")
		ENDIF()
	ENDIF()
ELSE(EXISTS "${CMAKE_SOURCE_DIR}/.git/")
	SET(GIT_VERSION "")
ENDIF(EXISTS "${CMAKE_SOURCE_DIR}/.git/")

IF(SUBPATCH_VERSION EQUAL "0")
	SET(FULLVERSION "${MAJOR_VERSION}.${MINOR_VERSION}.${PATCH_VERSION}${GIT_VERSION}")
ELSE(SUBPATCH_VERSION EQUAL "0")
	SET(FULLVERSION "${MAJOR_VERSION}.${MINOR_VERSION}.${PATCH_VERSION}.${SUBPATCH_VERSION}${GIT_VERSION}")
ENDIF(SUBPATCH_VERSION EQUAL "0")

SET(SHORTVERSION "${MINOR_VERSION}${PATCH_VERSION}${SUBPATCH_VERSION}")

CONFIGURE_FILE("${CMAKE_SOURCE_DIR}/src/version.h.in" "${CMAKE_CURRENT_BINARY_DIR}/version.h" @ONLY)
INCLUDE_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR})

# GCC 4.6+ is required, GCC_VERSION macro taken from GCC manual
INCLUDE(CheckCSourceCompiles)
IF(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
   CHECK_C_SOURCE_COMPILES("
   #define GCC_VERSION (__GNUC__ * 10000 + __GNUC_MINOR__ * 100 + __GNUC_PATCHLEVEL__)
   #if GCC_VERSION < 40600
   #error
   #endif
   int main() { return 0; }" GCC_IS_4_6)
   IF(NOT GCC_IS_4_6)
      MESSAGE(FATAL_ERROR "GCC 4.6+ is required.")
   ENDIF(NOT GCC_IS_4_6)
ENDIF(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")

# Find put the path of the gnash executable, if available
FIND_PROGRAM(GNASH_EXE_PATH NAMES gnash)

IF(GNASH_EXE_PATH)
	MESSAGE(STATUS "Found gnash path: ${GNASH_EXE_PATH}")
ELSE(GNASH_EXE_PATH)
# Set a default path
	MESSAGE(STATUS "Gnash not found")
	SET(GNASH_EXE_PATH "/usr/bin/gnash")
ENDIF(GNASH_EXE_PATH)

# Find out CPU architecture ...
#
# Setting the value of LIB_SUFFIX if not specified (We could build 32bit version on 64bit)
# However, some distro don't implement FHS the same way
# Suse, Redhat put 64bit libs in /lib64; Debian use /lib for 64bit, but specifies /lib32 for 32bit libs
# See FHS 2.3 for Lib directories under each architecture

IF(CMAKE_SIZEOF_VOID_P STREQUAL "8")
    ADD_DEFINITIONS(-DLIGHTSPARK_64)
endif(CMAKE_SIZEOF_VOID_P STREQUAL "8")
# Some directory shortcuts
SET(CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/conf)
INCLUDE(Pack)
# If we're gcc, then use nasm to get fastpath.  If MSVC, just use inline asm to get around
# CMake issues
IF(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
   INCLUDE(CMakeASM-NASMCompiler)
ENDIF(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
IF(${CMAKE_SYSTEM_PROCESSOR} MATCHES "^i[3-6]86$|^x86$")
	SET(i386 1)
	SET(LIB_SUFFIX "" CACHE STRING "Choose the suffix of the lib folder (if any) : None 32")
	# nasm for assembly optimizations
	IF(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
	   ENABLE_LANGUAGE(ASM-NASM)
	ENDIF(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
ELSEIF(${CMAKE_SYSTEM_PROCESSOR} MATCHES "unknown" AND ${CMAKE_SYSTEM} MATCHES "GNU-0.3")
	# GNU Hurd is i386
	SET(i386 1)
	SET(LIB_SUFFIX "" CACHE STRING "Choose the suffix of the lib folder (if any) : None 32")
	# nasm for assembly optimizations
	IF(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
	   ENABLE_LANGUAGE(ASM-NASM)
	ENDIF ()
ELSEIF(${CMAKE_SYSTEM_PROCESSOR} MATCHES "^x86_64$|^amd64$")
	SET(x86_64 1)
	SET(LIB_SUFFIX "" CACHE STRING "Choose the suffix of the lib folder (if any) : None 64")
	# nasm for assembly optimizations
	IF(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
	  ENABLE_LANGUAGE(ASM-NASM)
	ENDIF(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
ELSEIF(${CMAKE_SYSTEM_PROCESSOR} MATCHES "ppc")
	SET(ppc 1)
	SET(LIB_SUFFIX "" CACHE STRING "Choose the suffix of the lib folder (if any) : None ppc")
	SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -D__STDC_CONSTANT_MACROS -fPIC")
	IF(NOT(DISABLE_ALTIVEC))
		SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -maltivec")
	ENDIF()
ELSE(${CMAKE_SYSTEM_PROCESSOR} MATCHES "^i[3-6]86$|^x86$")
	# All non-x86 non-ppc architectures.
	SET(LIB_SUFFIX "" CACHE STRING "Choose the suffix of the lib folder (if any) : None")
ENDIF(${CMAKE_SYSTEM_PROCESSOR} MATCHES "^i[3-6]86$|^x86$")

IF(CMAKE_SYSTEM_NAME STREQUAL CMAKE_HOST_SYSTEM_NAME)
  SET(CROSSCOMPILING FALSE)
ELSE()
  SET(CROSSCOMPILING TRUE)
ENDIF()

#On mingw-cross-env, all depedencies are static libs
IF(CROSSCOMPILING AND MINGW)
  SET(STATICDEPS TRUE)
ELSE()
  SET(STATICDEPS FALSE)
ENDIF()

# Using relative folders, cmake happens by itself CMAKE_INSTALL_PREFIX
IF(UNIX)
   SET(ETCDIR "/etc") #Using absolute folder
   SET(BINDIR "bin")
   SET(DATADIR "share")
   # Absolute path, because this path is embedded in the binary
   SET(LSDATADIR "${CMAKE_INSTALL_PREFIX}/${DATADIR}/lightspark")
   SET(LIBDIR "lib${LIB_SUFFIX}")
   #We need a absolute path here because we use it for rpath
   #later on
   SET(PRIVATELIBDIR "${CMAKE_INSTALL_PREFIX}/${LIBDIR}/lightspark")
   SET(CMAKE_INSTALL_RPATH "${PRIVATELIBDIR}")
ELSE()
  SET(ETCDIR ".")
  SET(BINDIR ".")
  SET(DATADIR ".")
  SET(LSDATADIR ".")
  SET(LIBDIR ".")
  SET(PRIVATELIBDIR ".")
ENDIF(UNIX)

SET(CMAKE_INSTALL_PREFIX "/usr/local" CACHE PATH "Install prefix, default is /usr/local (UNIX) and C:\\Program Files (Windows)")
SET(COMPILE_LIGHTSPARK TRUE CACHE BOOL "Compile Lightspark?")
SET(COMPILE_TIGHTSPARK FALSE CACHE BOOL "Compile Tightspark?")
IF(EMSCRIPTEN)
SET(COMPILE_NPAPI_PLUGIN FALSE)
SET(COMPILE_PPAPI_PLUGIN FALSE)
SET(ENABLE_GLES2 TRUE)
ELSE()
SET(COMPILE_NPAPI_PLUGIN TRUE CACHE BOOL "Compile the npapi browser plugin?")
SET(COMPILE_PPAPI_PLUGIN TRUE CACHE BOOL "Compile the ppapi browser plugin?")
SET(ENABLE_GLES2 FALSE CACHE BOOL "Build with OpenGLES 2.0 support instead of OpenGL")
ENDIF(EMSCRIPTEN)
SET(ENABLE_CURL TRUE CACHE BOOL "Enable CURL? (Required for Downloader functionality)")
SET(ENABLE_LIBAVCODEC TRUE CACHE BOOL "Enable libavcodec and dependent functionality?")
SET(ENABLE_RTMP TRUE CACHE BOOL "Enable librtmp and dependent functionality?")
SET(ENABLE_LLVM FALSE CACHE BOOL "Enable support for llvm based jit execution (currently broken)")
SET(ENABLE_PROFILING FALSE CACHE BOOL "Enable profiling support? (Causes performance issues)")
SET(ENABLE_MEMORY_USAGE_PROFILING FALSE CACHE BOOL "Enable profiling of memory usage? (Causes performance issues)")
SET(PLUGIN_DIRECTORY "${LIBDIR}/mozilla/plugins" CACHE STRING "Directory to install Firefox plugin to")
SET(PPAPI_PLUGIN_DIRECTORY "${LIBDIR}/PepperFlash" CACHE STRING "Directory to install PPAPI plugin to")
SET(MANUAL_DIRECTORY "share/man" CACHE STRING "Directory to install manual to (UNIX only)")
SET(ENABLE_SSE2 TRUE CACHE BOOL "Enable use of SSE2 asm instructions (x86/x86_64 only)")

IF(ENABLE_DEBIAN_ALTERNATIVES OR WIN32)
  SET(PLUGIN_DIRECTORY ${PRIVATELIBDIR})
ENDIF()

IF(NOT CMAKE_BUILD_TYPE)
	SET(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING
		"Choose the type of build, options are: Debug Release RelWithDebInfo Profile" FORCE)
ENDIF(NOT CMAKE_BUILD_TYPE)

# The library is searched in its private library directory
SET(CMAKE_SKIP_BUILD_RPATH FALSE)
SET(CMAKE_INSTALL_RPATH "${PRIVATELIBDIR}")

# Libraries we need
INCLUDE(FindPkgConfig REQUIRED)

IF (ENABLE_LLVM)
	ADD_DEFINITIONS(-DLLVM_ENABLED)
	INCLUDE(FindLLVM REQUIRED)
	IF(${LLVM_STRING_VERSION} VERSION_LESS 2.8)
		MESSAGE(FATAL_ERROR "LLVM >=2.8 is required!")
	ENDIF(${LLVM_STRING_VERSION} VERSION_LESS 2.8)
	IF(${LLVM_STRING_VERSION} VERSION_EQUAL 2.9)
		MESSAGE(FATAL_ERROR "LLVM !=2.9 is required!")
	ENDIF(${LLVM_STRING_VERSION} VERSION_EQUAL 2.9)
	IF(${LLVM_STRING_VERSION} VERSION_EQUAL 2.8)
		ADD_DEFINITIONS(-DLLVM_28)
	ENDIF(${LLVM_STRING_VERSION} VERSION_EQUAL 2.8)
	IF(${LLVM_STRING_VERSION} VERSION_EQUAL 3.0)
		ADD_DEFINITIONS(-DLLVM_30)
	ENDIF(${LLVM_STRING_VERSION} VERSION_EQUAL 3.0)
	IF(${LLVM_STRING_VERSION} VERSION_GREATER 3.0)
		ADD_DEFINITIONS(-DLLVM_31)
	ENDIF(${LLVM_STRING_VERSION} VERSION_GREATER 3.0)
	IF(${LLVM_STRING_VERSION} VERSION_GREATER 3.3)
		ADD_DEFINITIONS(-DLLVM_34)
	ENDIF(${LLVM_STRING_VERSION} VERSION_GREATER 3.3)
	IF(${LLVM_STRING_VERSION} VERSION_GREATER 3.4)
		ADD_DEFINITIONS(-DLLVM_35)
	ENDIF(${LLVM_STRING_VERSION} VERSION_GREATER 3.4)
	IF(NOT (${LLVM_STRING_VERSION} VERSION_LESS 3.6))
		ADD_DEFINITIONS(-DLLVM_36)
	ENDIF(NOT (${LLVM_STRING_VERSION} VERSION_LESS 3.6))
	IF(NOT ${LLVM_STRING_VERSION} VERSION_LESS 3.7)
		ADD_DEFINITIONS(-DLLVM_37)
	ENDIF(NOT ${LLVM_STRING_VERSION} VERSION_LESS 3.7)
	IF(NOT ${LLVM_STRING_VERSION} VERSION_LESS 3.8)
		ADD_DEFINITIONS(-DLLVM_38)
	ENDIF(NOT ${LLVM_STRING_VERSION} VERSION_LESS 3.8)
	IF(NOT ${LLVM_STRING_VERSION} VERSION_LESS 5.0)
		ADD_DEFINITIONS(-DLLVM_50)
	ENDIF(NOT ${LLVM_STRING_VERSION} VERSION_LESS 5.0)
	IF(NOT ${LLVM_STRING_VERSION} VERSION_LESS 7.0)
		ADD_DEFINITIONS(-DLLVM_70)
	ENDIF(NOT ${LLVM_STRING_VERSION} VERSION_LESS 7.0)
ENDIF(ENABLE_LLVM)

IF(EMSCRIPTEN)
	SET(STATICDEPS TRUE)
	set(USE_FLAGS "-s USE_SDL=2 -s USE_FREETYPE=1 -s USE_ZLIB=1 -s USE_LIBJPEG=1 -s USE_LIBPNG=1")
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${USE_FLAGS}")
	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${USE_FLAGS}")
	set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} ${USE_FLAGS}")
	set(CMAKE_EXECUTABLE_SUFFIX .html)
ELSE()
	INCLUDE(FindZLIB REQUIRED)
	INCLUDE(FindFreetype REQUIRED)
	INCLUDE(FindJPEG REQUIRED)
	INCLUDE(FindPNG REQUIRED)
ENDIF(EMSCRIPTEN)
IF(NOT(ENABLE_GLES2))
	SET(OpenGL_GL_PREFERENCE LEGACY)
	INCLUDE(FindOpenGL REQUIRED)
	INCLUDE(FindGLEW REQUIRED)
	ADD_DEFINITIONS(-DNANOVG_GL2_IMPLEMENTATION)
ENDIF(NOT(ENABLE_GLES2))

pkg_check_modules(LZMA REQUIRED liblzma)
INCLUDE_DIRECTORIES(${LZMA_INCLUDE_DIRS})
SET(OPTIONAL_LIBRARIES ${OPTIONAL_LIBRARIES} ${LZMA_LIBRARIES})

pkg_check_modules(CAIRO REQUIRED cairo pangocairo)

IF(ENABLE_GLES2)
  pkg_check_modules(GLES2 REQUIRED egl glesv2)
  ADD_DEFINITIONS(-DENABLE_GLES2)
  ADD_DEFINITIONS(-DNANOVG_GLES2_IMPLEMENTATION)
ENDIF(ENABLE_GLES2)

IF(WIN32)
  SET(EXTRA_LIBS_LIBRARIES ${EXTRA_LIBS_LIBRARIES} ws2_32.lib imagehlp.lib)
ENDIF(WIN32)

IF(ENABLE_LIBAVCODEC)

=== src/CMakeLists.txt ===
#**************************************************************************
#    Lightspark, a free flash player implementation
#
#    Copyright (C) 2010-2013  Alessandro Pignotti <a.pignotti@sssup.it>
#    Copyright (C) 2010  Giacomo Spigler <g.spigler@sssup.it>
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Lesser General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Lesser General Public License for more details.
#
#   You should have received a copy of the GNU Lesser General Public License
#   along with this program.  If not, see <http://www.gnu.org/licenses/>.
#**************************************************************************

# liblightspark.so sources
SET(LIBSPARK_SOURCES
  allclasses.cpp
  asobject.cpp
  compat.cpp
  logger.cpp
  memory_support.cpp
  swf.cpp
  swftypes.cpp
  thread_pool.cpp
  threading.cpp
  timer.cpp
  tiny_string.cpp
  errorconstants.cpp
  backends/audio.cpp
  backends/builtindecoder.cpp
  backends/config.cpp
  backends/currency.cpp
  backends/decoder.cpp
  backends/extscriptobject.cpp
  backends/geometry.cpp
  backends/graphics.cpp
  backends/image.cpp
  backends/input.cpp
  backends/locale.cpp
  backends/netutils.cpp
  backends/rendering.cpp
  backends/rendering_context.cpp
  backends/rtmputils.cpp
  backends/security.cpp
  backends/streamcache.cpp
  backends/urlutils.cpp
  backends/xml_support.cpp
  parsing/amf3_generator.cpp
  parsing/config.cpp
  parsing/crossdomainpolicy.cpp
  parsing/flv.cpp
  parsing/streams.cpp
  parsing/tags.cpp
  parsing/tags_stub.cpp
  parsing/textfile.cpp
  scripting/abc.cpp
  scripting/abc_avm1.cpp
  scripting/abc_flashaccessibility.cpp
  scripting/abc_flashdesktop.cpp
  scripting/abc_flashconcurrent.cpp
  scripting/abc_flashcrypto.cpp
  scripting/abc_flashdisplay.cpp
  scripting/abc_flashdisplay3d.cpp
  scripting/abc_flashevents.cpp
  scripting/abc_flasherrors.cpp
  scripting/abc_flashexternal.cpp
  scripting/abc_flashfilesystem.cpp
  scripting/abc_flashfilters.cpp
  scripting/abc_flashgeom.cpp
  scripting/abc_flashglobalization.cpp
  scripting/abc_flashmedia.cpp
  scripting/abc_flashnet.cpp
  scripting/abc_flashprinting.cpp
  scripting/abc_flashsampler.cpp
  scripting/abc_flashsecurity.cpp
  scripting/abc_flashsensors.cpp
  scripting/abc_flashsystem.cpp
  scripting/abc_flashtext.cpp
  scripting/abc_flashui.cpp
  scripting/abc_flashutils.cpp
  scripting/abc_flashxml.cpp
  scripting/abc_avmplus.cpp
  scripting/abc_toplevel.cpp
  scripting/abc_codesynt.cpp
  scripting/abc_fast_interpreter.cpp
  scripting/abc_interpreter.cpp
  scripting/abc_methods.cpp
  scripting/abc_methods_optimized.cpp
  scripting/abc_optimizer.cpp
  scripting/abc_opcodes.cpp
  scripting/abctypes.cpp
  scripting/flash/accessibility/flashaccessibility.cpp
  scripting/flash/globalization/stringtools.cpp
  scripting/flash/concurrent/Mutex.cpp
  scripting/flash/concurrent/Condition.cpp
  scripting/flash/crypto/flashcrypto.cpp
  scripting/flash/desktop/clipboardformats.cpp
  scripting/flash/desktop/clipboardtransfermode.cpp
  scripting/flash/desktop/flashdesktop.cpp
  scripting/flash/display/BitmapContainer.cpp
  scripting/flash/display/BitmapData.cpp
  scripting/flash/display/bitmapencodingcolorspace.cpp
  scripting/flash/display/colorcorrection.cpp
  scripting/flash/display/ColorCorrectionSupport.cpp
  scripting/flash/display/DisplayObject.cpp
  scripting/flash/display/IBitmapDrawable.cpp
  scripting/flash/display/flashdisplay.cpp
  scripting/flash/display/TokenContainer.cpp
  scripting/flash/display/Graphics.cpp
  scripting/flash/display/GraphicsBitmapFill.cpp
  scripting/flash/display/GraphicsEndFill.cpp
  scripting/flash/display/GraphicsGradientFill.cpp
  scripting/flash/display/GraphicsPath.cpp
  scripting/flash/display/GraphicsShaderFill.cpp
  scripting/flash/display/GraphicsSolidFill.cpp
  scripting/flash/display/GraphicsStroke.cpp
  scripting/flash/display/GraphicsTrianglePath.cpp
  scripting/flash/display/NativeMenuItem.cpp
  scripting/flash/display/NativeWindow.cpp
  scripting/flash/display/jpegencoderoptions.cpp
  scripting/flash/display/jpegxrencoderoptions.cpp
  scripting/flash/display/pngencoderoptions.cpp
  scripting/flash/display/shaderparametertype.cpp
  scripting/flash/display/shaderprecision.cpp
  scripting/flash/display/swfversion.cpp
  scripting/flash/display/triangleculling.cpp
  scripting/flash/display3d/flashdisplay3d.cpp
  scripting/flash/display3d/flashdisplay3dtextures.cpp
  scripting/flash/events/flashevents.cpp
  scripting/flash/external/ExternalInterface.cpp
  scripting/flash/external/ExtensionContext.cpp
  scripting/flash/filters/flashfilters.cpp
  scripting/flash/filesystem/flashfilesystem.cpp
  scripting/flash/geom/flashgeom.cpp
  scripting/flash/geom/orientation3d.cpp
  scripting/flash/globalization/datetimeformatter.cpp
  scripting/flash/globalization/datetimestyle.cpp
  scripting/flash/globalization/lastoperationstatus.cpp
  scripting/flash/globalization/localeid.cpp
  scripting/flash/globalization/currencyformatter.cpp
  scripting/flash/globalization/currencyparseresult.cpp
  scripting/flash/globalization/numberformatter.cpp
  scripting/flash/globalization/numberparseresult.cpp
  scripting/flash/globalization/collator.cpp
  scripting/flash/globalization/collatormode.cpp
  scripting/flash/globalization/datetimenamecontext.cpp
  scripting/flash/globalization/datetimenamestyle.cpp
  scripting/flash/globalization/nationaldigitstype.cpp
  scripting/flash/media/flashmedia.cpp
  scripting/flash/media/audiodecoder.cpp
  scripting/flash/media/audiooutputchangereason.cpp
  scripting/flash/media/avnetworkingparams.cpp
  scripting/flash/media/avtagdata.cpp
  scripting/flash/media/h264level.cpp
  scripting/flash/media/h264profile.cpp
  scripting/flash/media/id3info.cpp
  scripting/flash/media/microphoneenhancedmode.cpp
  scripting/flash/media/microphoneenhancedoptions.cpp
  scripting/flash/media/soundcodec.cpp
  scripting/flash/media/stagevideoavailabilityreason.cpp
  scripting/flash/media/videodecoder.cpp
  scripting/flash/net/flashnet.cpp
  scripting/flash/net/netgroupreceivemode.cpp
  scripting/flash/net/netgroupreplicationstrategy.cpp
  scripting/flash/net/netgroupsendmode.cpp
  scripting/flash/net/netgroupsendresult.cpp
  scripting/flash/net/URLRequestHeader.cpp
  scripting/flash/net/URLStream.cpp
  scripting/flash/net/Socket.cpp
  scripting/flash/net/XMLSocket.cpp
  scripting/flash/net/NetStreamInfo.cpp
  scripting/flash/net/NetStreamPlayOptions.cpp
  scripting/flash/net/NetStreamPlayTransitions.cpp
  scripting/flash/net/DatagramSocket.cpp
  scripting/flash/printing/flashprinting.cpp
  scripting/flash/errors/flasherrors.cpp
  scripting/flash/sampler/flashsampler.cpp
  scripting/flash/security/certificatestatus.cpp
  scripting/flash/sensors/flashsensors.cpp
  scripting/flash/system/flashsystem.cpp
  scripting/flash/system/messagechannel.cpp
  scripting/flash/system/messagechannelstate.cpp
  scripting/flash/system/securitypanel.cpp
  scripting/flash/system/systemupdater.cpp
  scripting/flash/system/systemupdatertype.cpp
  scripting/flash/system/touchscreentype.cpp
  scripting/flash/system/ime.cpp
  scripting/flash/system/jpegloadercontext.cpp
  scripting/flash/text/csmsettings.cpp
  scripting/flash/text/flashtext.cpp
  scripting/flash/text/flashtextengine.cpp
  scripting/flash/text/textrenderer.cpp
  scripting/flash/utils/flashutils.cpp
  scripting/flash/utils/ByteArray.cpp
  scripting/flash/utils/CompressionAlgorithm.cpp
  scripting/flash/utils/Dictionary.cpp
  scripting/flash/utils/Proxy.cpp
  scripting/flash/utils/Timer.cpp
  scripting/flash/utils/IntervalManager.cpp
  scripting/flash/utils/IntervalRunner.cpp
  scripting/flash/ui/Keyboard.cpp
  scripting/flash/ui/Mouse.cpp
  scripting/flash/ui/Multitouch.cpp
  scripting/flash/ui/ContextMenu.cpp
  scripting/flash/ui/ContextMenuItem.cpp
  scripting/flash/ui/ContextMenuBuiltInItems.cpp
  scripting/flash/ui/gameinput.cpp
  scripting/flash/xml/flashxml.cpp
  scripting/toplevel/Array.cpp
  scripting/toplevel/ASString.cpp
  scripting/toplevel/Boolean.cpp
  scripting/toplevel/Date.cpp
  scripting/toplevel/Error.cpp
  scripting/toplevel/Integer.cpp
  scripting/toplevel/JSON.cpp
  scripting/toplevel/Math.cpp
  scripting/toplevel/Number.cpp
  scripting/toplevel/RegExp.cpp
  scripting/toplevel/UInteger.cpp
  scripting/toplevel/Vector.cpp
  scripting/toplevel/XML.cpp
  scripting/toplevel/XMLList.cpp
  scripting/class.cpp
  scripting/toplevel/toplevel.cpp
  scripting/avmplus/avmplus.cpp
  scripting/avm1/avm1key.cpp
  scripting/avm1/avm1sound.cpp
  scripting/avm1/avm1display.cpp
  scripting/avm1/avm1net.cpp
  scripting/avm1/avm1text.cpp
  scripting/avm1/avm1ui.cpp
  scripting/avm1/avm1xml.cpp
  scripting/avm1/avm1media.cpp
  scripting/avm1_interpreter.cpp
  platforms/engineutils.cpp
  3rdparty/nanovg/src/nanovg.c
  3rdparty/pugixml/src/pugixml.cpp
  3rdparty/jpegxr/cr_parse.cpp
  3rdparty/jpegxr/cw_emit.cpp
  3rdparty/jpegxr/jpegxr_algo.cpp
  3rdparty/jpegxr/jpegxr_api.cpp
  3rdparty/jpegxr/jpegxr_flags.cpp
  3rdparty/jpegxr/jpegxr_init.cpp
  3rdparty/jpegxr/jpegxr_io.cpp
  3rdparty/jpegxr/jpegxr_pixelformat.cpp
  3rdparty/jpegxr/r_parse.cpp
  3rdparty/jpegxr/r_strip.cpp
  3rdparty/jpegxr/r_tile_frequency.cpp
  3rdparty/jpegxr/r_tile_spatial.cpp
  3rdparty/jpegxr/w_emit.cpp
  3rdparty/jpegxr/w_strip.cpp
  3rdparty/jpegxr/w_tile_frequency.cpp
  3rdparty/jpegxr/w_tile_spatial.cpp
  3rdparty/jpegxr/x_strip.cpp
  3rdparty/avmplus/core/BigInteger.cpp
  3rdparty/avmplus/core/BigInteger.h
  3rdparty/avmplus/core/d2a.cpp
  3rdparty/avmplus/core/d2a.h
  3rdparty/avmplus/pcre/pcre_chartables.cpp
  3rdparty/avmplus/pcre/pcre_compile.cpp
  3rdparty/avmplus/pcre/pcre_config.cpp
  3rdparty/avmplus/pcre/pcre_dfa_exec.cpp
  3rdparty/avmplus/pcre/pcre_exec.cpp
  3rdparty/avmplus/pcre/pcre_fullinfo.cpp
  3rdparty/avmplus/pcre/pcre_get.cpp
  3rdparty/avmplus/pcre/pcre_globals.cpp
  3rdparty/avmplus/pcre/pcre_info.cpp
  3rdparty/avmplus/pcre/pcre_maketables.cpp
  3rdparty/avmplus/pcre/pcre_newline.cpp
  3rdparty/avmplus/pcre/pcre_ord2utf8.cpp
  3rdparty/avmplus/pcre/pcre_refcount.cpp
  3rdparty/avmplus/pcre/pcre_study.cpp
  3rdparty/avmplus/pcre/pcre_tables.cpp
  3rdparty/avmplus/pcre/pcre_try_flipped.cpp
  3rdparty/avmplus/pcre/pcre_valid_utf8.cpp
  3rdparty/avmplus/pcre/pcre_version.cpp
  3rdparty/avmplus/pcre/pcre_xclass.cpp
  3rdparty/avmplus/pcre/config.h
  3rdparty/avmplus/pcre/pcre.h
  3rdparty/avmplus/pcre/pcre_avmplus.h
  3rdparty/avmplus/pcre/pcre_internal.h
  3rdparty/avmplus/pcre/pcreposix.h
  3rdparty/avmplus/pcre/pcre_scanner.h
  )
IF(MINGW)
  SET(LIBSPARK_SOURCES ${LIBSPARK_SOURCES} platforms/slowpaths_generic.cpp)
ELSEIF(CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
    SET(LIBSPARK_SOURCES ${LIBSPARK_SOURCES} platforms/slowpaths_generic.cpp)
ELSE()
  IF(ENABLE_SSE2)
    IF(${i386})
      SET(LIBSPARK_SOURCES ${LIBSPARK_SOURCES} platforms/fastpaths_x86.cpp)
      SET(LIBSPARK_SOURCES ${LIBSPARK_SOURCES} platforms/fastpaths_i686.asm)
    ELSEIF(${x86_64})
      SET(LIBSPARK_SOURCES ${LIBSPARK_SOURCES} platforms/fastpaths_x86.cpp)
      SET(LIBSPARK_SOURCES ${LIBSPARK_SOURCES} platforms/fastpaths_amd64.asm)
    ELSE()
      SET(LIBSPARK_SOURCES ${LIBSPARK_SOURCES} platforms/slowpaths_generic.cpp)
    ENDIF(${i386})
  ELSE(ENABLE_SSE2)
    SET(LIBSPARK_SOURCES ${LIBSPARK_SOURCES} platforms/slowpaths_generic.cpp)
  ENDIF(ENABLE_SSE2)
ENDIF(MINGW)

INCLUDE_DIRECTORIES(${PROJECT_SOURCE_DIR}/src)
INCLUDE_DIRECTORIES(${PROJECT_SOURCE_DIR}/src/scripting)
INCLUDE_DIRECTORIES(${PROJECT_SOURCE_DIR}/src/3rdparty/jxrlib/jxrgluelib)
INCLUDE_DIRECTORIES(${PROJECT_SOURCE_DIR}/src/3rdparty/avmplus/pcre)

=== src/plugin/CMakeLists.txt ===
#**************************************************************************
#    Lightspark, a free flash player implementation
#
#    Copyright (C) 2010  Giacomo Spigler <g.spigler@sssup.it>
#    Copyright (C) 2010-2013  Alessandro Pignotti <a.pignotti@sssup.it>
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Lesser General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Lesser General Public License for more details.
#
#   You should have received a copy of the GNU Lesser General Public License
#   along with this program.  If not, see <http://www.gnu.org/licenses/>.
#**************************************************************************

# Dependencies
INCLUDE_DIRECTORIES("include")
INCLUDE_DIRECTORIES("..")
INCLUDE_DIRECTORIES("include/npapi")

INCLUDE_DIRECTORIES(${SDL2_INCLUDE_DIRS})
IF(WIN32)
	ADD_DEFINITIONS(-DXP_WIN)
ELSE()
	pkg_check_modules(X11 REQUIRED x11)
	ADD_DEFINITIONS(-DMOZ_X11)
	ADD_DEFINITIONS(-DXP_UNIX)
ENDIF()

# Firefox plugin target
SET(PLUGIN_SOURCES ${PLUGIN_SOURCES}
	np_entry.cpp
	npn_gate.cpp
	npp_gate.cpp
	plugin.cpp
	npscriptobject.cpp)

IF(WIN32)
	SET(PLUGIN_SOURCES ${PLUGIN_SOURCES} plugin.rc plugin.def)
ENDIF(WIN32)

ADD_LIBRARY(lightsparkplugin MODULE ${PLUGIN_SOURCES})

#With STATICDEPS, all deps are compiled into spark
IF(NOT STATICDEPS)
TARGET_LINK_LIBRARIES(lightsparkplugin spark)
ENDIF()

IF(WIN32)
  #For win32 firefox, plugins have to start with 'np'
  SET_TARGET_PROPERTIES(lightsparkplugin PROPERTIES OUTPUT_NAME nplightsparkplugin PREFIX "")
  SET_TARGET_PROPERTIES(lightsparkplugin PROPERTIES LINK_FLAGS "-Wl,--enable-stdcall-fixup")
  TARGET_LINK_LIBRARIES(lightsparkplugin -lopengl32 spark)
ELSE()
  TARGET_INCLUDE_DIRECTORIES(lightsparkplugin PRIVATE ${X11_INCLUDE_DIRS})
  TARGET_LINK_LIBRARIES(lightsparkplugin ${X11_LIBRARIES})
ENDIF()

PACK_LIBRARY(lightsparkplugin $<TARGET_FILE:lightsparkplugin>)
INSTALL(TARGETS lightsparkplugin DESTINATION ${PLUGIN_DIRECTORY})

=== src/plugin_ppapi/CMakeLists.txt ===
#**************************************************************************
#    Lightspark, a free flash player implementation
#
#    Copyright (C) 2016 Ludger Krämer <dbluelle@onlinehome.de>
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Lesser General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Lesser General Public License for more details.
#
#   You should have received a copy of the GNU Lesser General Public License
#   along with this program.  If not, see <http://www.gnu.org/licenses/>.
#**************************************************************************

include_directories(.)

# PPAPI plugin target
SET(PPAPI_PLUGIN_SOURCES ${PPAPI_PLUGIN_SOURCES}
	plugin.cpp
	ppextscriptobject.cpp
	)

ADD_LIBRARY(pepflashplayer MODULE ${PPAPI_PLUGIN_SOURCES})

TARGET_LINK_LIBRARIES(pepflashplayer spark)

#With STATICDEPS, all deps are compiled into spark
IF(NOT STATICDEPS)
TARGET_LINK_LIBRARIES(pepflashplayer spark)
ENDIF()

IF(WIN32)
  TARGET_LINK_LIBRARIES(pepflashplayer -lopengl32 spark)
ENDIF()

PACK_LIBRARY(pepflashplayer $<TARGET_FILE:pepflashplayer>)
INSTALL(TARGETS pepflashplayer DESTINATION ${PPAPI_PLUGIN_DIRECTORY})
INSTALL(FILES manifest.json DESTINATION ${PPAPI_PLUGIN_DIRECTORY})

=== debian/control ===
Source: lightspark
Section: utils
Priority: optional
Maintainer: Alessandro Pignotti <a.pignotti@sssup.it>
Build-Depends: g++ (>=4.5), cmake, nasm, debhelper (>= 7), libgl1-mesa-dev, libxext-dev, libcurl4-gnutls-dev | libcurl4-openssl-dev, zlib1g-dev, libavcodec-dev, libglew-dev, libcairo2-dev, libjpeg8-dev, libavformat-dev, libswresample-dev, libpango1.0-dev, librtmp-dev, liblzma-dev, libfreetype6-dev, libpng-dev, libsdl2-dev
Standards-Version: 3.8.4
Homepage: http://lightspark.github.io
Vcs-git: git://github.com/lightspark/lightspark.git
Vcs-Browser: https://github.com/lightspark/lightspark

Package: lightspark
Architecture: i386 amd64
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Experimental high-performance SWF (Adobe Flash) player
 Lightspark is a free Flash player for Linux which aims for high-performance
 by using modern technologies such as JIT compilation and OpenGL shaders.
 .
 The project is currently in alpha status, users are invited to test lightspark
 and report any issue
 .
 Nice features:
 * JIT compilation of ActionScript to native x86 bytecode
 * Hardware accelerated rendering using OpenGL shaders (GLSL)
 * Aims to support Actionscript 2 and ActionScript 3
 * A new, clean, codebase exploiting multithreading and optimized for modern
   hardware. Designed from scratch after the official Flash documentation was
   released.

Package: lightspark-common
Architecture: i386 amd64
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Experimental high-performance SWF (Adobe Flash) player
 Lightspark is a free Flash player for Linux which aims for high-performance
 by using modern technologies such as JIT compilation and OpenGL shaders.
 .
 The project is currently in alpha status, users are invited to test lightspark
 and report any issue
 .
 Nice features:
 * JIT compilation of ActionScript to native x86 bytecode
 * Hardware accelerated rendering using OpenGL shaders (GLSL)
 * Aims to support Actionscript 2 and ActionScript 3
 * A new, clean, codebase exploiting multithreading and optimized for modern
   hardware. Designed from scratch after the official Flash documentation was
   released.
 .
 Common library and data

Package: browser-plugin-lightspark
Architecture: i386 amd64
Xb-Npp-Applications: ec8030f7-c20a-464f-9b0e-13a3a9e97384
Xb-Npp-MimeType: application/x-shockwave-flash
Xb-Npp-Name: Lightspark SWF Player
Xb-Npp-Description: High performance SWF Player
Xb-Npp-File: liblightsparkplugin.so
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: gnash
Description: Experimental high-performance SWF (Adobe Flash) player
 Lightspark is a free Flash player for Linux which aims for high-performance
 by using modern technologies such as JIT compilation and OpenGL shaders.
 .
 The project is currently in alpha status, users are invited to test lightspark
 and report any issue
 .
 Nice features:
 * JIT compilation of ActionScript to native x86 bytecode
 * Hardware accelerated rendering using OpenGL shaders (GLSL)
 * Aims to support Actionscript 2 and ActionScript 3
 * A new, clean, codebase exploiting multithreading and optimized for modern
   hardware. Designed from scratch after the official Flash documentation was
   released.
 .
 Mozilla plugin package


Package: lightspark-dbg
Section: debug
Priority: extra
Architecture: i386 amd64
Depends: ${shlibs:Depends}, ${misc:Depends}, 
 lightspark (= ${binary:Version}) |
 browser-plugin-lightspark (= ${binary:Version}) |
 lightspark-common (= ${binary:Version})
Description: High-performance SWF player (experimental) - Debug symbols
 Lightspark is a free Flash player for Linux which aims for high-performance
 by using modern technologies such as JIT compilation and OpenGL shaders.
 .
 The project is currently in alpha status, users are invited to test lightspark
 and report any issue
 .
 Nice features:
 * JIT compilation of ActionScript to native x86 bytecode
 * Hardware accelerated rendering using OpenGL shaders (GLSL)
 * Aims to support Actionscript 2 and ActionScript 3
 * A new, clean, codebase exploiting multithreading and optimized for modern
   hardware. Designed from scratch after the official Flash documentation was
   released.
 .
 This package contains the debug symbols.
